[leedcode 216] Combination Sum III

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers.

Ensure that numbers within the set are sorted in ascending order.

Example 1:

Input: k = 3, n = 7

Output:

[[1,2,4]]

Example 2:

Input: k = 3, n = 9

Output:

[[1,2,6], [1,3,5], [2,3,4]]
public class Solution {
    List<List<Integer>> res;
    List<Integer> seq;
    public List<List<Integer>> combinationSum3(int k, int n) {
        //dfs,for循环和递归叠加。
        //需要保存level值,因为结果要求是递增的,同时为了确保是k个数,每一次递归,k要减一
        res=new ArrayList<List<Integer>>();
        seq=new ArrayList<Integer>();
        dfs(k,n,1,0);
        return res;
    }
    public void dfs(int k,int n,int start,int sum){
        if(sum==n&&k==0){
            res.add(new ArrayList<Integer>(seq));
        }else if(sum>n||k<=0) return;
        for(int i=start;i<=9;i++){
            seq.add(i);
            dfs(k-1,n,i+1,sum+i);
            seq.remove(seq.size()-1);
        }
    }
}
时间: 2024-10-27 06:43:53

[leedcode 216] Combination Sum III的相关文章

【LeetCode】216. Combination Sum III

Combination Sum III Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Ensure that numbers within the set are sorted in ascend

Java for LeetCode 216 Combination Sum III

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Ensure that numbers within the set are sorted in ascending order. Example 1

Leetcode 216. Combination Sum III

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Example 1: Input: k = 3, n = 7 Output: [[1,2,4]] Example 2: Input: k = 3, n

leetcode 216. Combination Sum III 求和III ---------- java

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Example 1: Input: k = 3, n = 7 Output: [[1,2,4]] Example 2: Input: k = 3, n

216. Combination Sum III java solutions

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Example 1: Input: k = 3, n = 7 Output: [[1,2,4]] Example 2: Input: k = 3, n

216 Combination Sum III

public class Combination_Sum_III { /** * 思路: * 只能使用1~9 * 例如: * 给定n=9 k=3,说明用3个数组成的和要等于9 * 当sum不等于9时,一直往后走: * [123]!=9 ==> [124]!=9 ==> [125]!=9 * 当sum等于9时,返回找下一个可能 * [126]=9 (原因:再往后走,就会比9大了,因为是递增的数列) * ==> [134]... * ---------------数据结构----------

LeetCode 216. Combination Sum III (组合的和之三)

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Example 1: Input: k = 3, n = 7 Output: [[1,2,4]] Example 2: Input: k = 3, n

216. Combination Sum III——本质DFS

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Example 1: Input: k = 3, n = 7 Output: [[1,2,4]] Example 2: Input: k = 3, n

216. Combination Sum III 组合总数三

Find all possible combinations of k numbers that add up to a number n, given that only numbers from 1 to 9 can be used and each combination should be a unique set of numbers. Example 1: Input: k = 3, n = 7 Output: [[1,2,4]] Example 2: Input: k = 3, n